Debian Bug report logs - #551926
RM: pip -- tool for scripted and third-party CPAN distribution installation

Package: ftp.debian.org; Maintainer for ftp.debian.org is Debian FTP Master <ftpmaster@ftp-master.debian.org>;

Reported by: Ralf Treinen <treinen@free.fr>

Date: Wed, 21 Oct 2009 20:18:02 UTC

Severity: serious

Done: Debian Archive Maintenance <ftpmaster@ftp-master.debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>:
Bug#551926; Package pip,python-pip. (Wed, 21 Oct 2009 20:18:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ralf Treinen <treinen@free.fr>:
New Bug report received and forwarded. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>.

Your message had a Version: pseudo-header with an invalid package version:

python-pip/0.3.1-1

please either use found or fixed to the control server with a correct version, or reply to this report indicating the correct version so the maintainer (or someone else) can correct it for you.

(Wed, 21 Oct 2009 20:18:05 GMT) Full text and rfc822 format available.


Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Ralf Treinen <treinen@free.fr>
To: submit@bugs.debian.org
Subject: python-pip and pip: error when trying to install together
Date: Wed, 21 Oct 2009 22:11:07 +0200
Package: pip,python-pip
Version: pip/0.13-1
Version: python-pip/0.3.1-1
Severity: serious
User: treinen@debian.org
Usertags: edos-file-overwrite

Date: 2009-10-21
Architecture: amd64
Distribution: sid

Hi,

automatic installation tests of packages that share a file and at the
same time do not conflict by their package dependency relationships has
detected the following problem:


WARNING: The following packages cannot be authenticated!
  libdb4.5 libsqlite3-0 mime-support python2.5-minimal python2.5
  python-minimal python python-central libcompress-bzip2-perl
  libnumber-compare-perl libtext-glob-perl libfile-find-rule-perl
  libdata-compare-perl libcpan-checksums-perl libparams-util-perl
  libfile-chmod-perl libcpan-inject-perl libfile-pushd-perl libfile-which-perl
  libhtml-tagset-perl liburi-perl libhtml-parser-perl libhtml-tree-perl
  libwww-perl pip python-pkg-resources python-pip
Authentication warning overridden.
Can not write log, openpty() failed (/dev/pts not mounted?)
Selecting previously deselected package libdb4.5.
(Reading database ... 10391 files and directories currently installed.)
Unpacking libdb4.5 (from .../libdb4.5_4.5.20-13_amd64.deb) ...
Selecting previously deselected package libsqlite3-0.
Unpacking libsqlite3-0 (from .../libsqlite3-0_3.6.19-1_amd64.deb) ...
Selecting previously deselected package mime-support.
Unpacking mime-support (from .../mime-support_3.46-1_all.deb) ...
Selecting previously deselected package python2.5-minimal.
Unpacking python2.5-minimal (from .../python2.5-minimal_2.5.4-2_amd64.deb) ...
Selecting previously deselected package python2.5.
Unpacking python2.5 (from .../python2.5_2.5.4-2_amd64.deb) ...
Selecting previously deselected package python-minimal.
Unpacking python-minimal (from .../python-minimal_2.5.4-2_all.deb) ...
Selecting previously deselected package python.
Unpacking python (from .../python_2.5.4-2_all.deb) ...
Selecting previously deselected package python-central.
Unpacking python-central (from .../python-central_0.6.11_all.deb) ...
Selecting previously deselected package libcompress-bzip2-perl.
Unpacking libcompress-bzip2-perl (from .../libcompress-bzip2-perl_2.09-2_amd64.deb) ...
Selecting previously deselected package libnumber-compare-perl.
Unpacking libnumber-compare-perl (from .../libnumber-compare-perl_0.01-6_all.deb) ...
Selecting previously deselected package libtext-glob-perl.
Unpacking libtext-glob-perl (from .../libtext-glob-perl_0.08-2_all.deb) ...
Selecting previously deselected package libfile-find-rule-perl.
Unpacking libfile-find-rule-perl (from .../libfile-find-rule-perl_0.30-3_all.deb) ...
Selecting previously deselected package libdata-compare-perl.
Unpacking libdata-compare-perl (from .../libdata-compare-perl_1.21-1_all.deb) ...
Selecting previously deselected package libcpan-checksums-perl.
Unpacking libcpan-checksums-perl (from .../libcpan-checksums-perl_2.03-1_all.deb) ...
Selecting previously deselected package libparams-util-perl.
Unpacking libparams-util-perl (from .../libparams-util-perl_1.00-1_amd64.deb) ...
Selecting previously deselected package libfile-chmod-perl.
Unpacking libfile-chmod-perl (from .../libfile-chmod-perl_0.32-1_all.deb) ...
Selecting previously deselected package libcpan-inject-perl.
Unpacking libcpan-inject-perl (from .../libcpan-inject-perl_0.11-1_all.deb) ...
Selecting previously deselected package libfile-pushd-perl.
Unpacking libfile-pushd-perl (from .../libfile-pushd-perl_1.00-1_all.deb) ...
Selecting previously deselected package libfile-which-perl.
Unpacking libfile-which-perl (from .../libfile-which-perl_1.08-1_all.deb) ...
Selecting previously deselected package libhtml-tagset-perl.
Unpacking libhtml-tagset-perl (from .../libhtml-tagset-perl_3.20-2_all.deb) ...
Selecting previously deselected package liburi-perl.
Unpacking liburi-perl (from .../liburi-perl_1.37+dfsg-1_all.deb) ...
Selecting previously deselected package libhtml-parser-perl.
Unpacking libhtml-parser-perl (from .../libhtml-parser-perl_3.62-1_amd64.deb) ...
Selecting previously deselected package libhtml-tree-perl.
Unpacking libhtml-tree-perl (from .../libhtml-tree-perl_3.23-1_all.deb) ...
Selecting previously deselected package libwww-perl.
Unpacking libwww-perl (from .../libwww-perl_5.833-1_all.deb) ...
Selecting previously deselected package pip.
Unpacking pip (from .../archives/pip_0.13-1_all.deb) ...
Selecting previously deselected package python-pkg-resources.
Unpacking python-pkg-resources (from .../python-pkg-resources_0.6.4-1_all.deb) ...
Selecting previously deselected package python-pip.
Unpacking python-pip (from .../python-pip_0.3.1-1_all.deb) ...
dpkg: error processing /var/cache/apt/archives/python-pip_0.3.1-1_all.deb (--unpack):
 trying to overwrite '/usr/bin/pip', which is also in package pip 0:0.13-1
Processing triggers for man-db ...
Errors were encountered while processing:
 /var/cache/apt/archives/python-pip_0.3.1-1_all.deb
E: Sub-process /usr/bin/dpkg returned an error code (1)


This is a serious bug as it makes installation fail, and violate
section 7.6.1 of the policy. Possible solutions are to have the two
packages conflict, to rename the common file in one of the two
packages, or to remove the file from one package and have this package
depend on the other package. File diversions or a Replace relation are
another possibility.

Here is a list of files that are known to be shared by both packages
(according to the Contents file for sid/amd64, which may be
slightly out of sync):


  usr/bin/pip
  

This bug is assigned to both packages. If you, the maintainers of
the two packages in question, have agreed on which of the packages will
resolve the problem please reassign the bug to that package.

-Ralf.

PS: for more information about the detection of file overwrite errors
of this kind see http://edos.debian.net/file-overwrites/.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>:
Bug#551926; Package pip,python-pip. (Sun, 29 Nov 2009 21:51:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tim Retout <tim@retout.co.uk>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>. (Sun, 29 Nov 2009 21:51:13 GMT) Full text and rfc822 format available.

Message #10 received at 551926@bugs.debian.org (full text, mbox):

From: Tim Retout <tim@retout.co.uk>
To: debian-devel@bugs.debian.org
Cc: 551926@bugs.debian.org, adamk@cpan.org
Subject: Re: bug #551926: python-pip and pip: error when trying to install together
Date: Sun, 29 Nov 2009 21:48:13 +0000
[Message part 1 (text/plain, inline)]
[Copying debian-devel, the bug report, and the upstream author of the
Perl pip.]

According to Debian Policy 10.1 [*], when two binaries have different
functionality but the same name, this should be reported to the
debian-devel mailing list.

[*] http://www.debian.org/doc/debian-policy/ch-files.html#s10.1

In this case, 'pip' and 'python-pip' both ship /usr/bin/pip, but one is
for Perl and one is for Python. The 'python-pip' package has precedence
in Debian (and indeed, is the only one in testing), so I propose that
the Perl pip package must pick a pseudonym for its program.

My first suggestion is 'pip-perl', so that it's still possible to find
via tab-completion on 'pip'.  Better ideas welcomed, otherwise I'll make
the change in a few days.

This isn't ideal for having the same name for the Perl pip on all
platforms, I know - but until we fix this, there will be a serious bug
on 'pip', and it will not be released with Debian.

Regards,

-- 
Tim Retout <tim@retout.co.uk>
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>:
Bug#551926; Package pip,python-pip. (Sun, 29 Nov 2009 22:03:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tim Retout <tim@retout.co.uk>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>. (Sun, 29 Nov 2009 22:03:07 GMT) Full text and rfc822 format available.

Message #15 received at 551926@bugs.debian.org (full text, mbox):

From: Tim Retout <tim@retout.co.uk>
To: debian-devel@lists.debian.org
Cc: 551926@bugs.debian.org, adamk@cpan.org
Subject: Re: bug #551926: python-pip and pip: error when trying to install together
Date: Sun, 29 Nov 2009 21:57:57 +0000
[Message part 1 (text/plain, inline)]
[Resending to the *actual* debian-devel address. :) D'oh.]

According to Debian Policy 10.1 [*], when two binaries have different
functionality but the same name, this should be reported to the
debian-devel mailing list.

[*] http://www.debian.org/doc/debian-policy/ch-files.html#s10.1

In this case, 'pip' and 'python-pip' both ship /usr/bin/pip, but one is
for Perl and one is for Python. The 'python-pip' package has precedence
in Debian (and indeed, is the only one in testing), so I propose that
the Perl pip package must pick a pseudonym for its program.

My first suggestion is 'pip-perl', so that it's still possible to find
via tab-completion on 'pip'.  Better ideas welcomed, otherwise I'll make
the change in a few days.

This isn't ideal for having the same name for the Perl pip on all
platforms, I know - but until we fix this, there will be a serious bug
on 'pip', and it will not be released with Debian.

Regards,

-- 
Tim Retout <tim@retout.co.uk>

[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>:
Bug#551926; Package pip,python-pip. (Mon, 30 Nov 2009 01:06:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to adam@ali.as:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>. (Mon, 30 Nov 2009 01:06:02 GMT) Full text and rfc822 format available.

Message #20 received at 551926@bugs.debian.org (full text, mbox):

From: Adam Kennedy <adamkennedybackup@gmail.com>
To: Tim Retout <tim@retout.co.uk>
Cc: debian-devel@lists.debian.org, 551926@bugs.debian.org, adamk@cpan.org
Subject: Re: bug #551926: python-pip and pip: error when trying to install together
Date: Mon, 30 Nov 2009 12:01:51 +1100
http://blog.ianbicking.org/2008/10/28/pyinstall-is-dead-long-live-pip/

The Perl package predates the Python one by several years.

The author was made aware of the clash well before it was shipped to
Debian and chose to continue anyway.

Adam K

2009/11/30 Tim Retout <tim@retout.co.uk>:
> [Resending to the *actual* debian-devel address. :) D'oh.]
>
> According to Debian Policy 10.1 [*], when two binaries have different
> functionality but the same name, this should be reported to the
> debian-devel mailing list.
>
> [*] http://www.debian.org/doc/debian-policy/ch-files.html#s10.1
>
> In this case, 'pip' and 'python-pip' both ship /usr/bin/pip, but one is
> for Perl and one is for Python. The 'python-pip' package has precedence
> in Debian (and indeed, is the only one in testing), so I propose that
> the Perl pip package must pick a pseudonym for its program.
>
> My first suggestion is 'pip-perl', so that it's still possible to find
> via tab-completion on 'pip'.  Better ideas welcomed, otherwise I'll make
> the change in a few days.
>
> This isn't ideal for having the same name for the Perl pip on all
> platforms, I know - but until we fix this, there will be a serious bug
> on 'pip', and it will not be released with Debian.
>
> Regards,
>
> --
> Tim Retout <tim@retout.co.uk>
>
>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>:
Bug#551926; Package pip,python-pip. (Mon, 30 Nov 2009 02:21:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Yu <jonathan.i.yu@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>. (Mon, 30 Nov 2009 02:21:03 GMT) Full text and rfc822 format available.

Message #25 received at 551926@bugs.debian.org (full text, mbox):

From: Jonathan Yu <jonathan.i.yu@gmail.com>
To: debian-devel@lists.debian.org
Cc: adam@ali.as, 551926@bugs.debian.org, adamk@cpan.org
Subject: Re: bug #551926: python-pip and pip: error when trying to install together
Date: Sun, 29 Nov 2009 21:17:36 -0500
Hi:

[Cc'ing Adam Kennedy since I'm not sure if he's subscribed to debian-devel]

Since Adam mentions that Perl's pip predates Python's pip by a
significant margin, I think we should close this issue by renaming
Python's installer back to pyinstall. It doesn't seem fair for someone
who came on the scene later (who didn't do the appropriate research,
and who, when prompted with the problem, decided to proceed with pip
anyway) to be able to usurp the namespace from Perl.

I'd personally object to renaming Perl's pip to anything else given
these issues.

An alternative arrangement I'd be open to is:
/usr/bin/pip points to a sh script, which tells the user that `pip'
has been renamed to perl-pip and python-pip in Debian. This way,
neither pip gets the /usr/bin/pip name. However, I'm not sure about
how to do this (I guess it'd need to be handled like the dual-life
Perl modules are, via divert and all that...). Again, I don't think
it's fair for Perl's pip to lose `pip' just because some other author
is a jerk (even if Python's pip just so happened to be packaged
first).

Cheers,

Jonathan

On Sun, Nov 29, 2009 at 8:01 PM, Adam Kennedy
<adamkennedybackup@gmail.com> wrote:
> http://blog.ianbicking.org/2008/10/28/pyinstall-is-dead-long-live-pip/
>
> The Perl package predates the Python one by several years.
>
> The author was made aware of the clash well before it was shipped to
> Debian and chose to continue anyway.
>
> Adam K
>
> 2009/11/30 Tim Retout <tim@retout.co.uk>:
>> [Resending to the *actual* debian-devel address. :) D'oh.]
>>
>> According to Debian Policy 10.1 [*], when two binaries have different
>> functionality but the same name, this should be reported to the
>> debian-devel mailing list.
>>
>> [*] http://www.debian.org/doc/debian-policy/ch-files.html#s10.1
>>
>> In this case, 'pip' and 'python-pip' both ship /usr/bin/pip, but one is
>> for Perl and one is for Python. The 'python-pip' package has precedence
>> in Debian (and indeed, is the only one in testing), so I propose that
>> the Perl pip package must pick a pseudonym for its program.
>>
>> My first suggestion is 'pip-perl', so that it's still possible to find
>> via tab-completion on 'pip'.  Better ideas welcomed, otherwise I'll make
>> the change in a few days.
>>
>> This isn't ideal for having the same name for the Perl pip on all
>> platforms, I know - but until we fix this, there will be a serious bug
>> on 'pip', and it will not be released with Debian.
>>
>> Regards,
>>
>> --
>> Tim Retout <tim@retout.co.uk>
>>
>>
>
>
> --
> To UNSUBSCRIBE, email to debian-devel-REQUEST@lists.debian.org
> with a subject of "unsubscribe". Trouble? Contact listmaster@lists.debian.org
>
>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>:
Bug#551926; Package pip,python-pip. (Mon, 30 Nov 2009 03:06:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Cyril Brulebois <kibi@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>. (Mon, 30 Nov 2009 03:06:02 GMT) Full text and rfc822 format available.

Message #30 received at 551926@bugs.debian.org (full text, mbox):

From: Cyril Brulebois <kibi@debian.org>
To: debian-devel@lists.debian.org, adam@ali.as, 551926@bugs.debian.org, adamk@cpan.org
Subject: Re: bug #551926: python-pip and pip: error when trying to install together
Date: Mon, 30 Nov 2009 04:02:13 +0100
[Message part 1 (text/plain, inline)]
Jonathan Yu <jonathan.i.yu@gmail.com> (29/11/2009):
> An alternative arrangement I'd be open to is: /usr/bin/pip points to
> a sh script, which tells the user that `pip' has been renamed to
> perl-pip and python-pip in Debian. This way, neither pip gets the
> /usr/bin/pip name.

Mentioning $LANG in the binary is the way to go. Bonus points if
obfuscated. What about pip, pipp, and ppip? Then, you even get room
for php!

Mraw,
KiBi.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>:
Bug#551926; Package pip,python-pip. (Mon, 30 Nov 2009 09:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tim Retout <tim@retout.co.uk>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>. (Mon, 30 Nov 2009 09:51:03 GMT) Full text and rfc822 format available.

Message #35 received at 551926@bugs.debian.org (full text, mbox):

From: Tim Retout <tim@retout.co.uk>
To: adam@ali.as
Cc: debian-devel@lists.debian.org, 551926@bugs.debian.org, python-virtualenv@groups.google.com
Subject: Re: bug #551926: python-pip and pip: error when trying to install together
Date: Mon, 30 Nov 2009 09:49:18 +0000
[CCing to python-pip upstream. Ian et. al.: please see
http://bugs.debian.org/551926 for the context of this email.  In
short, Debian needs to rename at least one of the 'pip' binaries.]

On Mon, Nov 30, 2009 at 12:01:51PM +1100, Adam Kennedy wrote:
> http://blog.ianbicking.org/2008/10/28/pyinstall-is-dead-long-live-pip/
> 
> The Perl package predates the Python one by several years.
> 
> The author was made aware of the clash well before it was shipped to
> Debian and chose to continue anyway.

This seems like a valid point.  I would like to hear the opinion of the
upstream author of python-pip on which should be renamed.

Ultimately this decision will be made by the Debian maintainers of the
packages, but I reckon it's best to involve upstream as far as possible
with changes of this kind.

If we cannot agree on the right course of action, both programs will be
renamed.

Regards,

-- 
Tim Retout <tim@retout.co.uk>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>:
Bug#551926; Package pip,python-pip. (Mon, 30 Nov 2009 11:06:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tim Retout <tim@retout.co.uk>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>. (Mon, 30 Nov 2009 11:06:06 GMT) Full text and rfc822 format available.

Message #40 received at 551926@bugs.debian.org (full text, mbox):

From: Tim Retout <tim@retout.co.uk>
To: Cyril Brulebois <kibi@debian.org>
Cc: debian-devel@lists.debian.org, adam@ali.as, 551926@bugs.debian.org, adamk@cpan.org
Subject: Use of sarcasm on mailing lists (was: Re: bug #551926: python-pip and pip: error when trying to install together)
Date: Mon, 30 Nov 2009 11:04:32 +0000
On Mon, Nov 30, 2009 at 04:02:13AM +0100, Cyril Brulebois wrote:
> Mentioning $LANG in the binary is the way to go. Bonus points if
> obfuscated. What about pip, pipp, and ppip? Then, you even get room
> for php!

At the risk of sounding like a killjoy, I do not feel that sarcasm is an
effective means of communicating your points, especially when attempting
a potentially delicate negotiation between Debian and upstream.

I think you may have a valid point about the choice of binary name, but
it is difficult for me to evaluate it when presented in this manner.  I
do not wish to imply that I consent to the use of sarcasm by remaining
silent about this - but please feel free to restate your point in a
different way. :)

Thanks,

-- 
Tim Retout <tim@retout.co.uk>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>:
Bug#551926; Package pip,python-pip. (Mon, 30 Nov 2009 23:21:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tim Retout <tim@retout.co.uk>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>. (Mon, 30 Nov 2009 23:21:03 GMT) Full text and rfc822 format available.

Message #45 received at 551926@bugs.debian.org (full text, mbox):

From: Tim Retout <tim@retout.co.uk>
To: Ian Bicking <ianb@colorstudy.com>
Cc: adam@ali.as, debian-devel@lists.debian.org, 551926@bugs.debian.org
Subject: Re: bug #551926: python-pip and pip: error when trying to install together
Date: Mon, 30 Nov 2009 23:20:26 +0000
[Resending to Ian Bicking's direct email address, since the
virtualenv list address bounced.]

On Mon, Nov 30, 2009 at 09:49:18AM +0000, Tim Retout wrote:
> On Mon, Nov 30, 2009 at 12:01:51PM +1100, Adam Kennedy wrote:
> > http://blog.ianbicking.org/2008/10/28/pyinstall-is-dead-long-live-pip/
> > 
> > The Perl package predates the Python one by several years.
> > 
> > The author was made aware of the clash well before it was shipped to
> > Debian and chose to continue anyway.
> 
> This seems like a valid point.  I would like to hear the opinion of the
> upstream author of python-pip on which should be renamed.
> 
> Ultimately this decision will be made by the Debian maintainers of the
> packages, but I reckon it's best to involve upstream as far as possible
> with changes of this kind.
> 
> If we cannot agree on the right course of action, both programs will be
> renamed.

Ian, please see the thread starting at:
http://lists.debian.org/debian-devel/2009/11/msg01034.html

In short, Debian must rename at least one of the binaries called 'pip'.

My first thought was to rename the perl pip because it was a more
recent addition to Debian, but it's been pointed out that Perl's pip
predates the Python one.  Do you have any thoughts as to how we should
proceed?

-- 
Tim Retout <tim@retout.co.uk>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>:
Bug#551926; Package pip,python-pip. (Tue, 01 Dec 2009 07:39:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Frank Lin PIAT <fpiat@klabs.be>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>. (Tue, 01 Dec 2009 07:39:09 GMT) Full text and rfc822 format available.

Message #50 received at 551926@bugs.debian.org (full text, mbox):

From: Frank Lin PIAT <fpiat@klabs.be>
To: 551926@bugs.debian.org, Debian Developers <debian-devel@lists.debian.org>
Subject: Re: bug #551926: python-pip and pip: error when trying to install together
Date: Tue, 01 Dec 2009 08:29:48 +0100
On Sun, 2009-11-29 at 21:17 -0500, Jonathan Yu wrote:
> Hi:
> 
> [Cc'ing Adam Kennedy since I'm not sure if he's subscribed to debian-devel]
> 
> Since Adam mentions that Perl's pip predates Python's pip by a
> significant margin, I think we should close this issue by renaming
> Python's installer back to pyinstall. It doesn't seem fair for someone
> who came on the scene later (who didn't do the appropriate research,
> and who, when prompted with the problem, decided to proceed with pip
> anyway) to be able to usurp the namespace from Perl.

Some facts:
-----------

pip
 - It's in the archive since 2002-08
 - It never entered testing or stable
 - It's average popcon since 2004 is about 10 (out of 70000)
 - It's popularity suddenly increased in Octobre (reaching 68)

python-pip
- It's in the archive since 2009-04
- It is in testing
- It's popcon is slowly and constantly increasing, reaching 57/70000

Why (perl) pip popcon suddenly[1] reached 68? Is it due to the new
version, or is it due to people installing it by mistake?


Non-factual!
------------

WTF? 
1. Can't perl and python upstream just talk together, this is not
   just about Debian. Having two ${p}-installer-program it just so
   convenient, what ever the platform!
2. <flame>
   Don't we use apt/dpkg in Debian?
   Do those $pip install stuffs outside /usr/local?
   Shouldn't those packages description mention that users should
   ITP/RFP desired modules? and that modules installed "manually" are
   guaranteed to:
   - Never be upgraded by Debian on upgrade/security updates
   - Conflict with some properly installed packages
   - Download untrusted/unsigned material (?)
   - Download stuffs with unknown license (?)
   - Never be supported by Debian
   </flame>


/usr/bin/pip should be a wrapper to invoke perl-pip and python-pop
randomly, in order to be really fair.

My 2¢

Franklin


popcon data:

2009-05: python-pip      3     0     0     3     0
2009-05: pip             8     1     7     0     0
2009-06: python-pip      18    0     6    12     0
2009-06: pip             8     1     7     0     0
2009-07: python-pip      19    1    15     3     0
2009-07: pip             8     0     8     0     0
2009-08: python-pip      25    1    15     9     0
2009-08: pip             8     0     8     0     0
2009-09: python-pip      32    6    20     6     0
2009-09: pip             9     0     9     0     0
2009-10: python-pip     42    11    25     6     0
2009-10: pip             9     0     9     0     0
2009-11: python-pip     51     9    34     8     0
2009-11: pip            19     4     7     8     0
2009-12: python-pip     55    14    34     7     0
2009-12: pip            68    15    10    43     0

[1] http://qa.debian.org/popcon.php?package=pip
    http://qa.debian.org/popcon.php?package=python-pip





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>:
Bug#551926; Package pip,python-pip. (Tue, 01 Dec 2009 11:42:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tim Retout <tim@retout.co.uk>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>. (Tue, 01 Dec 2009 11:42:11 GMT) Full text and rfc822 format available.

Message #55 received at 551926@bugs.debian.org (full text, mbox):

From: Tim Retout <tim@retout.co.uk>
To: Frank Lin PIAT <fpiat@klabs.be>
Cc: 551926@bugs.debian.org, Debian Developers <debian-devel@lists.debian.org>
Subject: Re: bug #551926: python-pip and pip: error when trying to install together
Date: Tue, 1 Dec 2009 11:39:32 +0000
On Tue, Dec 01, 2009 at 08:29:48AM +0100, Frank Lin PIAT wrote:
> Why (perl) pip popcon suddenly[1] reached 68? Is it due to the new
> version, or is it due to people installing it by mistake?

The Debian 'pip' package from 2002 was not the same program as
today's 'pip'; that one eventually got removed from the archive.
So the popcon numbers are not directly comparable.

Regarding whether we should package these tools at all, I could
note that the Perl policy makes provisions for users who install
modules from CPAN [0], and this seems like just a special case to me.

[0] http://www.debian.org/doc/packaging-manuals/perl-policy/ch-site.html

So I think we need to keep both tools, and should focus on resolving
the overlapping binary names.

Regards,

-- 
Tim Retout <tim@retout.co.uk>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>:
Bug#551926; Package pip,python-pip. (Tue, 01 Dec 2009 21:33:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Bicking <ianb@colorstudy.com>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Jeff Licquia <licquia@debian.org>. (Tue, 01 Dec 2009 21:33:07 GMT) Full text and rfc822 format available.

Message #60 received at 551926@bugs.debian.org (full text, mbox):

From: Ian Bicking <ianb@colorstudy.com>
To: Tim Retout <tim@retout.co.uk>
Cc: adam@ali.as, debian-devel@lists.debian.org, 551926@bugs.debian.org
Subject: Re: bug #551926: python-pip and pip: error when trying to install together
Date: Tue, 1 Dec 2009 15:29:26 -0600
[Message part 1 (text/plain, inline)]
On Mon, Nov 30, 2009 at 5:20 PM, Tim Retout <tim@retout.co.uk> wrote:

> Ian, please see the thread starting at:
> http://lists.debian.org/debian-devel/2009/11/msg01034.html
>
> In short, Debian must rename at least one of the binaries called 'pip'.
>
> My first thought was to rename the perl pip because it was a more
> recent addition to Debian, but it's been pointed out that Perl's pip
> predates the Python one.  Do you have any thoughts as to how we should
> proceed?
>

I'll note I did at least do some research before the renaming, but Perl's
pip had such poor google ratings (and generally a minimal web presence) that
it didn't show up in my research, and I only heard of it when I announced
the new name.  At that time no one actually asked me to rename pip, so I
just let it go.  Also the Perl pip's web presence was such that it was
unclear that it was actively being used and developed.

But I suppose pypip would be a reasonable name.  pyinstall doesn't read
right now that it's a two-level command.  python-pip seems unnecessarily
long-winded.

Note also that with virtualenv 1.4.1 (newer than the current Debian package,
I think), pip is automatically installed in all new environments.  Meaning
you do:

  $ virtualenv my-env
  $ my-env/bin/pip install ...

It would be inconsistent with many online documents to rename this binary.
 At the same time, there's no particular conflict since that script is
localized to a Python-specific environment.  Which I guess makes me think:
I'm not particularly concerned with the system-level packaging of pip, as I
think system-level Python libraries should be installed through the Debian
packaging system, and pip (which doesn't use Debian packages) should be used
in concert with virtualenv to install local versions of libraries.

-- 
Ian Bicking  |  http://blog.ianbicking.org  |
http://topplabs.org/civichacker
[Message part 2 (text/html, inline)]

Bug Marked as found in versions python-pip/0.3.1-1.1. Request was from Ralf Treinen <treinen@debian.org> to control@bugs.debian.org. (Wed, 09 Dec 2009 23:09:09 GMT) Full text and rfc822 format available.

Bug Marked as found in versions python-pip/0.6.1-1. Request was from Ralf Treinen <treinen@debian.org> to control@bugs.debian.org. (Mon, 21 Dec 2009 06:12:06 GMT) Full text and rfc822 format available.

Bug Marked as found in versions pip/1.16-1. Request was from Ralf Treinen <treinen@debian.org> to control@bugs.debian.org. (Mon, 01 Feb 2010 07:36:08 GMT) Full text and rfc822 format available.

Bug reassigned from package 'pip,python-pip' to 'pip,python-pip,rt-tests'. Request was from Ralf Treinen <treinen@debian.org> to control@bugs.debian.org. (Thu, 25 Feb 2010 06:18:03 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions python-pip/0.6.1-1, python-pip/0.3.1-1.1, and pip/1.16-1. Request was from Ralf Treinen <treinen@debian.org> to control@bugs.debian.org. (Thu, 25 Feb 2010 06:18:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>, Uwe Kleine-König <u.kleine-koenig@pengutronix.de>:
Bug#551926; Package pip,python-pip,rt-tests. (Thu, 25 Feb 2010 06:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ralf Treinen <treinen@free.fr>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>, Uwe Kleine-König <u.kleine-koenig@pengutronix.de>. (Thu, 25 Feb 2010 06:33:03 GMT) Full text and rfc822 format available.

Message #75 received at 551926@bugs.debian.org (full text, mbox):

From: Ralf Treinen <treinen@free.fr>
To: 551926@bugs.debian.org
Subject: rt-tests: cannot be installed together with pip or pip-python
Date: Thu, 25 Feb 2010 07:31:03 +0100
Hello,

now the package rt-tests (version 0.66-1) has joined the club of
packages claiming /usr/bin/pip as theirs:

Unpacking rt-tests (from .../rt-tests_0.66-1_amd64.deb) ...
dpkg: error processing /var/cache/apt/archives/rt-tests_0.66-1_amd64.deb (--unpa
ck):
 trying to overwrite '/usr/bin/pip', which is also in package pip 0:1.16-1


-Ralf.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip,rt-tests. (Thu, 25 Feb 2010 08:57:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Uwe Kleine-König <u.kleine-koenig@pengutronix.de>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Thu, 25 Feb 2010 08:57:08 GMT) Full text and rfc822 format available.

Message #80 received at 551926@bugs.debian.org (full text, mbox):

From: Uwe Kleine-König <u.kleine-koenig@pengutronix.de>
To: Ralf Treinen <treinen@free.fr>, 551926@bugs.debian.org
Cc: John Kacur <jkacur@redhat.com>, Clark Williams <williams@redhat.com>
Subject: Re: Bug#551926: rt-tests: cannot be installed together with pip or pip-python
Date: Thu, 25 Feb 2010 09:54:20 +0100
On Thu, Feb 25, 2010 at 07:31:03AM +0100, Ralf Treinen wrote:
> Hello,
> 
> now the package rt-tests (version 0.66-1) has joined the club of
> packages claiming /usr/bin/pip as theirs:
> 
> Unpacking rt-tests (from .../rt-tests_0.66-1_amd64.deb) ...
> dpkg: error processing /var/cache/apt/archives/rt-tests_0.66-1_amd64.deb (--unpa
> ck):
>  trying to overwrite '/usr/bin/pip', which is also in package pip 0:1.16-1
I will try to sort this out with upstream.

Clark, John: would you mind to rename pip to say piptest?

Best regards
Uwe

-- 
Pengutronix e.K.                           | Uwe Kleine-König            |
Industrial Linux Solutions                 | http://www.pengutronix.de/  |




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>, Uwe Kleine-König <u.kleine-koenig@pengutronix.de>:
Bug#551926; Package pip,python-pip,rt-tests. (Thu, 25 Feb 2010 13:33:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to John Kacur <jkacur@redhat.com>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>, Uwe Kleine-König <u.kleine-koenig@pengutronix.de>. (Thu, 25 Feb 2010 13:33:09 GMT) Full text and rfc822 format available.

Message #85 received at 551926@bugs.debian.org (full text, mbox):

From: John Kacur <jkacur@redhat.com>
To: Uwe Kleine-König <u.kleine-koenig@pengutronix.de>
Cc: Clark Williams <williams@redhat.com>, Ralf Treinen <treinen@free.fr>, 551926@bugs.debian.org
Subject: Re: Bug#551926: rt-tests: cannot be installed together with pip or pip-python
Date: Thu, 25 Feb 2010 08:27:42 -0500 (EST)
----- "Uwe Kleine-König" <u.kleine-koenig@pengutronix.de> wrote:

> On Thu, Feb 25, 2010 at 07:31:03AM +0100, Ralf Treinen wrote:
> > Hello,
> > 
> > now the package rt-tests (version 0.66-1) has joined the club of
> > packages claiming /usr/bin/pip as theirs:
> > 
> > Unpacking rt-tests (from .../rt-tests_0.66-1_amd64.deb) ...
> > dpkg: error processing
> /var/cache/apt/archives/rt-tests_0.66-1_amd64.deb (--unpa
> > ck):
> >  trying to overwrite '/usr/bin/pip', which is also in package pip
> 0:1.16-1
> I will try to sort this out with upstream.
> 
> Clark, John: would you mind to rename pip to say piptest?
> 

How about pip_stress? If you care to write the patch, I'll ack it.

Thanks.




Bug 551926 cloned as bug 572104. Request was from Uwe Kleine-König <u.kleine-koenig@pengutronix.de> to control@bugs.debian.org. (Mon, 01 Mar 2010 15:42:05 GMT) Full text and rfc822 format available.

Bug reassigned from package 'pip,python-pip,rt-tests' to 'pip,python-pip'. Request was from Uwe Kleine-König <u.kleine-koenig@pengutronix.de> to control@bugs.debian.org. (Mon, 01 Mar 2010 15:42:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip. (Sun, 21 Mar 2010 21:00:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Carl Chenet <chaica@ohmytux.com>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Sun, 21 Mar 2010 21:00:06 GMT) Full text and rfc822 format available.

Message #94 received at 551926@bugs.debian.org (full text, mbox):

From: Carl Chenet <chaica@ohmytux.com>
To: 551926@bugs.debian.org
Cc: ryan@debian.org, jawnsy@cpan.org, gregoa@debian.org, Sandro Tosi <morph@debian.org>
Subject: Re: cannot be installed together with pip or pip-python
Date: Sun, 21 Mar 2010 22:02:16 +0100
Hi,

I'm a new maintainer for the python-pip package and it would be great to
solve this blocking issue.

The python-pip and pip packages have quite the same popcon, and it is
hard to select one using the name "pip".

What about using python-pip for the executable of the python-pip package
and using perl-pip for the executable of the pip package?

We need to reach a good solution for both of the packages as soon as
possible.

Bye,
-- 
Carl Chenet







Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip. (Sun, 21 Mar 2010 21:48:21 GMT) Full text and rfc822 format available.

Acknowledgement sent to gregor herrmann <gregoa@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Sun, 21 Mar 2010 21:48:21 GMT) Full text and rfc822 format available.

Message #99 received at 551926@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: Carl Chenet <chaica@ohmytux.com>
Cc: 551926@bugs.debian.org, Sandro Tosi <morph@debian.org>, Ian Bicking <ianb@colorstudy.com>
Subject: Re: cannot be installed together with pip or pip-python
Date: Sun, 21 Mar 2010 22:46:34 +0100
[Message part 1 (text/plain, inline)]
On Sun, 21 Mar 2010 22:02:16 +0100, Carl Chenet wrote:

> I'm a new maintainer for the python-pip package and it would be great to
> solve this blocking issue.

Thanks for coming back to that issue, and we really should solve
this!
 
> What about using python-pip for the executable of the python-pip package
> and using perl-pip for the executable of the pip package?

To be honest: Since the perl pip is older and Ian was considering a
rename to pypip [0] my hope was that we can leave the perl package
as-is and the python package would first change upstream and then in
Debian. (In general I see no advantage of changing two binaries in
Debian.)

CC'ing Ian to get an update on his point of view.

Cheers,
gregor 

[0]
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=551926#60 
-- 
 .''`.   http://info.comodo.priv.at/ -- GPG Key IDs: 0x8649AA06, 0x00F3CFE4
 : :' :  Debian GNU/Linux user, admin, & developer - http://www.debian.org/
 `. `'   Member of VIBE!AT & SPI, fellow of Free Software Foundation Europe
   `-    NP: Queen: My Baby Does Me
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip. (Sun, 21 Mar 2010 22:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Bicking <ianb@colorstudy.com>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Sun, 21 Mar 2010 22:03:03 GMT) Full text and rfc822 format available.

Message #104 received at 551926@bugs.debian.org (full text, mbox):

From: Ian Bicking <ianb@colorstudy.com>
To: gregor herrmann <gregoa@debian.org>
Cc: Carl Chenet <chaica@ohmytux.com>, 551926@bugs.debian.org, Sandro Tosi <morph@debian.org>
Subject: Re: cannot be installed together with pip or pip-python
Date: Sun, 21 Mar 2010 16:57:49 -0500
[Message part 1 (text/plain, inline)]
I won't rename pip upstream.  The Perl pip package didn't show any
liveliness, was not packaged, and both our commands are superseded by
another old command line tool called pip for dealing with pipes -- that
project isn't causing any naming problems despite having had a better online
presence than pip (though it appears by now that the presence of Perl's pip
has come up slightly to reverse that).  No one asked or even suggested I
rename pip when I announced the name, someone merely noted that a tool with
the same name existed.

Personally I think virtualenv is more reasonable to package anyway, and it
includes pip in a localized way that avoids name clashes.


On Sun, Mar 21, 2010 at 4:46 PM, gregor herrmann <gregoa@debian.org> wrote:

> On Sun, 21 Mar 2010 22:02:16 +0100, Carl Chenet wrote:
>
> > I'm a new maintainer for the python-pip package and it would be great to
> > solve this blocking issue.
>
> Thanks for coming back to that issue, and we really should solve
> this!
>
> > What about using python-pip for the executable of the python-pip package
> > and using perl-pip for the executable of the pip package?
>
> To be honest: Since the perl pip is older and Ian was considering a
> rename to pypip [0] my hope was that we can leave the perl package
> as-is and the python package would first change upstream and then in
> Debian. (In general I see no advantage of changing two binaries in
> Debian.)
>
> CC'ing Ian to get an update on his point of view.
>
> Cheers,
> gregor
>
> [0]
> http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=551926#60
> --
>  .''`.   http://info.comodo.priv.at/ -- GPG Key IDs: 0x8649AA06,
> 0x00F3CFE4
>  : :' :  Debian GNU/Linux user, admin, & developer -
> http://www.debian.org/
>  `. `'   Member of VIBE!AT & SPI, fellow of Free Software Foundation Europe
>   `-    NP: Queen: My Baby Does Me
>
> -----BEGIN PGP SIGNATURE-----
> Version: GnuPG v1.4.10 (GNU/Linux)
>
> iQIcBAEBCAAGBQJLppO3AAoJELs6aAGGSaoGkwgQALKmgnrX2MttBkAimtznYssj
> KUxEJOWKJxJ4KOK30BeYvgXhufQGnRNQ0UsE/7C0rzhPDxGOMurRDhzxDsqRdAaK
> 7KcDKWj2L7ZWv2Lz0npS8AaaEOD0nCYn0/SkjCsPFtxsJbe/EV6G4roG1WEIxx5z
> Z33gSO8zNivgllAWefliWB/+Z+CjO+xyhBQF18mIEy4a+h6nrGgd31kUwasl8GB7
> O7s6/5yaDJmf3YwTCzGx+UpYZH7TpUsf6H0GjGBkV4/iApxN5RiBvq8+SlaWXl2g
> EjVrfGhR6GMIbrW+0PISi/DIvEiPLNz7LDCfMPscoYhxOsxaKMohS3AEXYjWFzJe
> n8DbKDbAtY1GcI2jVs995oBOt/lnK2gmznSBZlW1AAjddZo1tcea33xCfRrYEDD5
> jsu89v9Q66+5K/emqUGKwUPajts9lbpCmwH5hTxwuaw9FUaNsyfVrm9AKzxBtgsN
> zy4LDVpSrPkIOUnPxfQOPu+xglX+bYlmvPy57Sk42heHocr/BIZ7Lyj39W22XRn0
> UESva2Q9Twk4t+TF72RkyTlMiuYPKaWFk77D/3LOPXc/K+yNND9qQDPt2LGEIlNN
> SIf1kM2RteO+lKG2BBqE3IvQTUZ7A2a9C4afYaotIZp/QLjMd8q22MJFFnyzUR9d
> yxMXcA5qqkYh0or5smBN
> =WPsA
> -----END PGP SIGNATURE-----
>
>


-- 
Ian Bicking  |  http://blog.ianbicking.org  |  http://twitter.com/ianbicking
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip. (Tue, 23 Mar 2010 03:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Bicking <ianb@colorstudy.com>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Tue, 23 Mar 2010 03:51:03 GMT) Full text and rfc822 format available.

Message #109 received at 551926@bugs.debian.org (full text, mbox):

From: Ian Bicking <ianb@colorstudy.com>
To: gregor herrmann <gregoa@debian.org>
Cc: Carl Chenet <chaica@ohmytux.com>, 551926@bugs.debian.org, Sandro Tosi <morph@debian.org>
Subject: Re: cannot be installed together with pip or pip-python
Date: Mon, 22 Mar 2010 22:49:24 -0500
[Message part 1 (text/plain, inline)]
Just to confirm my intuition, I did a little bit of research:

* Perl pip 1.16 was release November 2009, pip 0.13 (the previous version)
was released December 2007.  There's no evidence of development in the svn
repository between those times, why 0.13 jumped to 1.16 I don't know.
* Python pip 0.2 was released October 2008 and has had 11 releases since
then.
* Perl's pip has 3 open bugs and zero closed bugs.
* Python's pip has 37 open bugs (okay, more than I'd like) and 44 closed
bugs.
* Python's pip has 41 forked repositories and 160 followers on bitbucket.
* I've invested significantly in the pip name and idea.  I see no evidence
of any such investment for Perl's pip.  Zero.
* Maybe there is a shadow user base of Perl's pip, but if so they've
boycotted the web.
* There have been 82k cumulative downloads of Python pip via PyPI (I can't
compare to Perl's pip though, as CPAN doesn't track these numbers).
* There have been 126k cumulative downloads of virtualenv which include
Python pip (virtualenv has included pip since version 1.3.1)

So I'll stand firmly by the name: I and a lot of other people have invested
in the code, the brand, and the idea of Python's pip, and I see no evidence
of any investment in Perl's pip.  It's hard to find a name for a project,
requiring that there be no overlap with any discarded or lightly maintained
project out there is too much to ask.
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip. (Tue, 23 Mar 2010 09:15:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Adam Kennedy <Adam.Kennedy@ce.com.au>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Tue, 23 Mar 2010 09:15:06 GMT) Full text and rfc822 format available.

Message #114 received at 551926@bugs.debian.org (full text, mbox):

From: Adam Kennedy <Adam.Kennedy@ce.com.au>
To: "551926@bugs.debian.org" <551926@bugs.debian.org>
Subject: I've been asked to contribute again to this thread
Date: Tue, 23 Mar 2010 19:35:14 +1100
[Message part 1 (text/plain, inline)]
With regards to messages #104 and #109, I have the following notes.

> The Perl pip package didn't show any liveliness

You clarify this in #109, but if by this you mean you checked Google and Debian and then assumed that was enough I agree.

When I created pip, I did something similar. I checked Debian and found that the binary name was free, checked Google and found only the pipes thing and confirmed it was removed.

Given the long history of Perl, Python and PHP dancing around words beginning with P I also checked the main package repositories for all three languages and found nothing. A trivial search for "pip" on search.cpan would have seen the following. http://search.cpan.org/search?query=pip&mode=all

> as not packaged,

Tprimary distribution method of Perl for software authors is the CPAN (as this covers all operating systems) and the Debian Perl people choose from the 20,000 CPAN packages and run the package automation and do their due diligence as they see fit. There is no expectation for authors to push to have things packaged in Debian. In fact, it's often quite the opposite, as the number of CPAN packages is higher than the total number of Debian packages (or at least, it used to be).

> and both our commands are superseded by another old command line
> tool called pip for dealing with pipes

True

> that project isn't causing any naming problems despite having had a better online
presence than pip.

What's actually interesting about it is that it's a Perl program, built like a CPAN distribution, but never uploaded to CPAN. But regardless, the last release was in 2003, it hadn't had a release for 5 years before this issue even came up.

> No one asked or even suggested I rename pip when I announced the name,
> someone merely noted that a tool with the same name existed.

I would consider an existing Perl, Python, PHP in any of the big repositories with the same command line a huge red flag, because automated packages methods exist for all of these and it's pretty obvious that there's going to be a naming clash in the downstream. If not immediately, then certainly inevitably.

As for nobody suggesting you rename it...

http://blog.ianbicking.org/2008/10/28/pyinstall-is-dead-long-live-pip/

James Bennett kicked off the alternate naming discuss with the humerous suggestion of pippiintpip ("pippiintpip installs Python packages, it is not the Perl Installation Program").

"Grink" expressed support for the Perl version, and suggested pypi.

"flowblock" complained it was too much like pypi, and then suggested renaming to the (excellent in my opinion) "pyp".

And Anatoly Techtonik suggests the alternate name of "pint".

The pyp name in particular seems like a perfect choice, since it fits the py theme and sounds identical so it wouldn't even require a change to spoken conversation. But alternate names are your choice, I only wanted to point out you had 5 people in the renaming discussion.

Moving on to #109

>  Just to confirm my intuition, I did a little bit of research:
>
> * Perl pip 1.16 was release November 2009, pip 0.13 (the previous version)
> was released December 2007.  There's no evidence of development in the svn
> repository between those times, why 0.13 jumped to 1.16 I don't know.

http://search.cpan.org/~adamk/pip-1.16/

Here's the main distribution page for pip.

The current version is 1.16.

In the rather prominent "Special Files" section, we can clearly see the Changes file for pip (which has been the file that contains the list of changes for over a decade, even the old pipe-related pip uses it).

http://search.cpan.org/src/ADAMK/pip-1.16/Changes

According to the Changes file, the previous version was 1.15, which was preceded by 0.14.

The 1.15 changes note an upgrade of the packaging, and a switch from a development version (starting in zero) to a production version (starting with a one). This is fairly common thing to do when your distribution has reached maturity and hasn't required any new feature or had any bugs for a while. Personally, I do it after a year without any bugs or fixes being required.

As for why it hasn't needed significant improvements, it's because it's a front end application. The application is modular, does a few specific tasks around the packaging and handoff. But most of the work is done by various parts of the pre-existing parts of the toolchain like CPAN.pm, PAR::Dist, Archive::Zip, and so on.

Pip also has a good chunk of the backend refactored out for use without all the weight of a command line interface being needed, in the form of things like CPAN::Inject. If python-pip has chosen to go with a more monolithic structure (which is completely understand given the nature of toolchain work, and less mature source repositories) I don't see how that necessarily counts in it's favour.

> * Python pip 0.2 was released October 2008 and has had 11 releases since then.

Perl pip was released in October 2006 and has had 14 releases since then. CPAN::Inject was created October 2006 outside the pip namespace to provide a generalised approach to CPAN injection, and has had 10 releases since then. Pip also uncovered a number of issues in Perl's primary Archive::Zip, which I took and have done 15 releases of since then, including work funded by a Perl Foundation development grant. Pip also uncovered issues in tarballs and CPAN and CPANPLUS and any number of other places. The total number of releases due to pip or weaknesses uncovered by it is around 40.

Fortunately, because all of this core toolchain support exists and doesn't need to be replicated, most bugs in pip aren't actually bugs in pip, they are bugs in a dependency. And so pip itself can reach maturity and convert to doing trickle releases of small pip-specific issues from time to time, while automatically picking up a stream of continuous improvements without any need for a release or work at all.

> * Perl's pip has 3 open bugs and zero closed bugs.

Perl's pip actually has one bug, although it certainly had a bunch more during it's initial creation. I checked the RT list you mentioned, and killed one that wasn't a bug at all, made a one line change to fix the second (thanks for the reminder). And the third is a feature request, not a bug. And a pretty wish'y feature at that).

Of course, if we're competing to have the MOST bugs (if you are treating bug counts as representative of activity) Archive::Zip has 40, cpan has another 50 or so, CPAN::Inject has a number, and so on.

> * Python's pip has 37 open bugs (okay, more than I'd like) and 44 closed
bugs.
> * Python's pip has 41 forked repositories and 160 followers on bitbucket.

I don't contest that Python's pip is a larger codebase with a larger scope, and more core, with more scope for bugs to sneak in, and with more people working to improve it.

Perl's pip unabashedly provides the ability to install any package of any type onto any operating system. That's all it does, and it does it well. Source packages, binary packages, anything. I don't see how having a program with a more contained scope to precisely what it's name says, and greater use of the luxury of pre-existing libraries to solve most of the hard installation issues, should count against me somehow.

Pip doesn't have all this traffic, because it doesn't need it. It works, and it works well, and it had largely reached that point before Python pip even existed.

> * I've invested significantly in the pip name and idea.  I see no evidence
> of any such investment for Perl's pip.  Zero.

I'm not sure what you mean by this. What kind of information am I supposed to provide here that you haven't found? I can't see any evidence of expensive trade marks, or a company named after it, or even of it's own domain (it's hosted under The Open Planning Project website). And as for the idea of installing packages from a repository, we've all probably invested way too much time in our respective toolchains.

> * Maybe there is a shadow user base of Perl's pip, but if so
> they've boycotted the web.

Pip is used by Padre, the Perl IDE, to install arbitrary packages to the OS. Given the explosion in popularity of Padre, that would certainly count for the popcon numbers. And yes, by and large Perl people don't need to use the public internet as much, as the CPAN cloud provides a huge range of parallel sites. And the very large numbers of sysadmins in Perl's ranks means we have our own IRC network, and the dozen to two dozen sites in the CPAN cloud, and our own repository managers, and so on.

Since you mention it, I believe it's also been mentioned in a German Perl magazine as well.

> * There have been 82k cumulative downloads of Python pip via PyPI (I can't
> compare to Perl's pip though, as CPAN doesn't track these numbers).

Correct, there's no real way of measuring CPAN's download numbers. There's 300 mirrors in the network, which makes it pretty much impossible.
But it's often mentioned in live support IRC channels, and is used in companies to script multi-step installs where they want to use something other than the latest releases, or want to mix their own non-open-source packages or patched packages into the install sequence. And it's regularly used by CPAN authors to advertise installation of new tarballs that haven't had time to sync to the mirror network yet.

> There have been 126k cumulative downloads of virtualenv which include
> Python pip (virtualenv has included pip since version 1.3.1)

There have been 475k cumulative downloads of the headline Google Code distributed versions of Strawberry Perl
which include Perl pip (Strawberry has included pip since the January 2008 quarterly release).
It's also installed in the Padre standalone Perl distributions for Windows, Mac and Linux.
And it's included in the FOSWiki Windows installer as well, I believe.

> So I'll stand firmly by the name: I and a lot of other people have invested
> in the code, the brand, and the idea of Python's pip, and I see no evidence
> of any investment in Perl's pip.  It's hard to find a name for a project,
> requiring that there be no overlap with any discarded or lightly maintained
> project out there is too much to ask.

Clearly preventing collisions with software that nobody uses is an issue, and one I don't feel it's necessary to fix (the download page for the pipe-related pip lists 381 total downloads). But that does not apply in this case.

This problem could easily have been resolved before it happened with a trivial search on the other two P language primary repositories.

This problem could easily have been resolved on the very first day the original mistake was made clear.

This problem could easily have been resolved by mailing the existing pip author's email address (i.e. me) plastered all over the Perl pip documentation and asking what state it was in.

Two different people told you about the collision, and 3 people suggested alternative names (I'll ignore the joke name)

As someone that clearly does large amounts of toolchain development, if you failed to see the problem would happen, and failed to correct the problem when you were told about it and when it was easy to fix and "just let it go" and didn't even ask me about it, because nobody told you loadly enough to fix it, I fail to see why the onus is on me to resolve a problem of your creation when I was the one that DID do the necessary due diligence to address the issue of naming collision.

Adam K




The information contained in this email and any attached files are strictly
private and confidential. This email should be read by the intended addressee
only. If the recipient of this message is not the intended addressee, please
call Corporate Express Australia Limited on +61 2 9335 0555 or Corporate Express
New Zealand Limited on +64 9 271 7600 and promptly delete this email and any
attachments. The intended recipient of this email may only use, reproduce,
disclose or distribute the information contained in this email and any attached
files with Corporate Express' permission. If you are not the intended addressee,
you are strictly prohibited from using, reproducing, disclosing or distributing
the information contained in this email and any attached files. Corporate
Express advises that this email and any attached files should be scanned to
detect viruses. Corporate Express accepts no liability for loss or damage
(whether caused by negligence or not) resulting from the use of any attached
files.
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip. (Tue, 23 Mar 2010 17:12:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Bicking <ianb@colorstudy.com>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Tue, 23 Mar 2010 17:12:06 GMT) Full text and rfc822 format available.

Message #119 received at 551926@bugs.debian.org (full text, mbox):

From: Ian Bicking <ianb@colorstudy.com>
To: gregor herrmann <gregoa@debian.org>
Cc: Carl Chenet <chaica@ohmytux.com>, 551926@bugs.debian.org, Sandro Tosi <morph@debian.org>
Subject: Re: cannot be installed together with pip or pip-python
Date: Tue, 23 Mar 2010 12:10:29 -0500
> > No one asked or even suggested I rename pip when I announced the name,
> > someone merely noted that a tool with the same name existed.
>
> I would consider an existing Perl, Python, PHP in any of the big repositories with the same command line a huge red flag, because automated packages methods exist for all of these and it's pretty obvious that there's going to be a naming clash in the downstream. If not immediately, then certainly inevitably.

It wasn't packaged in any repository I looked in.  As noted,
python-pip entered Debian testing first, while the Perl pip languished
for years.

> > * I've invested significantly in the pip name and idea.  I see no evidence
> > of any such investment for Perl's pip.  Zero.
>
> I'm not sure what you mean by this. What kind of information am I supposed to provide here that you haven't found? I can't see any evidence of expensive trade marks, or a company named after it, or even of it's own domain (it's hosted under The Open Planning Project website). And as for the idea of installing packages from a repository, we've all probably invested way too much time in our respective toolchains.

When researching project names I look to web searches to determine if
a name is unique enough, no name is perfectly unique so I have to
settle for "unique enough".  Outside of CPAN Perl's pip is completely
invisible.  If I search for "perl pip" I get a few CPAN pages, a
couple automated emails about packaging, a bunch of stuff about the
Python pip, and references to this name conflict.  I thought I saw
something at number 19:
http://ericholscher.com/blog/2009/nov/5/adding-testing-pip/ ... but
no, it's referring to Perl and CPAN and Python pip.  At 23 I see a
reference to Strawberry
(http://szabgab.com/blog/2010/01/1263492546.html).  From there I start
seeing threads that include someone named Pip, or other unrelated
projects.

As for investment, work is an investment, and I and many people have
written extensively about pip and discussed it online.  A domain was
purchased a while back (pip-installer.org) but we haven't switched
over yet so it just redirects.  I consider work around project
identity to be real work, and that perspective is directly reflected
in the web search results -- compare a search of "python pip" to a
search of "perl pip".

Lastly, the matter of users and the confusion of a Debian-specific
rename of a script: many packages refer specifically to "pip install
mypackage" in their instructions.  Here is a list of packages that
specifically refer to "pip install" in their docs on PyPI:
http://bit.ly/bNjfDf -- if Debian renames pip those instructions will
not work if you use python-pip.  I'm not sure what equivalent search I
might do for Perl pip, "pip p5i" shows only two relevant results.
Even if people are discussing these things on IRC, you'd expect
someone to document installation instructions, wouldn't you?  pip p5i
plan files are something that is reasonable to put in version control,
so I'd expect something better than this for search results:
http://bit.ly/9C4dUo (compare to: http://bit.ly/d9ONni)




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip. (Fri, 07 May 2010 14:57:13 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Fri, 07 May 2010 14:57:13 GMT) Full text and rfc822 format available.

Message #124 received at 551926@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Carl Chenet <chaica@ohmytux.com>
Cc: 551926@bugs.debian.org, ryan@debian.org, jawnsy@cpan.org, gregoa@debian.org, Sandro Tosi <morph@debian.org>
Subject: Re: cannot be installed together with pip or pip-python
Date: Fri, 7 May 2010 16:52:15 +0200
Hi,


On Sun, 21 Mar 2010, Carl Chenet wrote:
> I'm a new maintainer for the python-pip package and it would be great to
> solve this blocking issue.
> 
> The python-pip and pip packages have quite the same popcon, and it is
> hard to select one using the name "pip".

I think the issue has been open for long enough without clear consensus.
Hence all packages should rename their /usr/bin/pip to something else and
document the difference vs upstream in README.Debian.

BTW, finding new names is hard, but choosing a 3 letter acronym is a
recipe for problems...

Please take care to coordinate with other depending packages if needed
(virtualenv for python-pip?).

Cheers,
-- 
Raphaël Hertzog

Like what I do? Sponsor me: http://ouaza.com/wp/2010/01/05/5-years-of-freexian/
My Debian goals: http://ouaza.com/wp/2010/01/09/debian-related-goals-for-2010/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip. (Sat, 08 May 2010 08:57:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sandro Tosi <morph@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Sat, 08 May 2010 08:57:03 GMT) Full text and rfc822 format available.

Message #129 received at 551926@bugs.debian.org (full text, mbox):

From: Sandro Tosi <morph@debian.org>
To: Raphael Hertzog <hertzog@debian.org>, 551926@bugs.debian.org
Cc: Carl Chenet <chaica@ohmytux.com>, gregoa@debian.org, ryan@debian.org, jawnsy@cpan.org
Subject: Re: [Python-modules-team] Bug#551926: cannot be installed together with pip or pip-python
Date: Sat, 8 May 2010 10:51:33 +0200
Hi Raphael,

On Fri, May 7, 2010 at 16:52, Raphael Hertzog <hertzog@debian.org> wrote:
> Hi,
>
>
> On Sun, 21 Mar 2010, Carl Chenet wrote:
>> I'm a new maintainer for the python-pip package and it would be great to
>> solve this blocking issue.
>>
>> The python-pip and pip packages have quite the same popcon, and it is
>> hard to select one using the name "pip".
>
> I think the issue has been open for long enough without clear consensus.
> Hence all packages should rename their /usr/bin/pip to something else and
> document the difference vs upstream in README.Debian.
>
> BTW, finding new names is hard, but choosing a 3 letter acronym is a
> recipe for problems...
>
> Please take care to coordinate with other depending packages if needed
> (virtualenv for python-pip?).

of course I'm s little biased on this, but I'm attending Pycon italia
and 2 talks (over the 4 given by know) already provide explicit
references to pip and also about how to use it (that's as simple as
"pip install <module>").

I don't know how strong is the tool 'pip' into the perl world, but
it's absolutely well known, used and strongly suggested (along with
virtualenv) in the Python world, so diverging from its original name
would be another source of frustration for the python community
willing to use debian (and that community is already being harmed
several times).

Regards,
-- 
Sandro Tosi (aka morph, morpheus, matrixhasu)
My website: http://matrixhasu.altervista.org/
Me at Debian: http://wiki.debian.org/SandroTosi




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip. (Sat, 08 May 2010 12:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Yu <jawnsy@cpan.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Sat, 08 May 2010 12:30:03 GMT) Full text and rfc822 format available.

Message #134 received at 551926@bugs.debian.org (full text, mbox):

From: Jonathan Yu <jawnsy@cpan.org>
To: Sandro Tosi <morph@debian.org>, 551926@bugs.debian.org
Cc: Raphael Hertzog <hertzog@debian.org>, ryan@debian.org, Carl Chenet <chaica@ohmytux.com>, gregoa@debian.org
Subject: Re: Bug#551926: [Python-modules-team] Bug#551926: cannot be installed together with pip or pip-python
Date: Sat, 8 May 2010 08:27:40 -0400
Hi,

On Sat, May 8, 2010 at 4:51 AM, Sandro Tosi <morph@debian.org> wrote:
>> I think the issue has been open for long enough without clear consensus.
>> Hence all packages should rename their /usr/bin/pip to something else and
>> document the difference vs upstream in README.Debian.
>>
>> BTW, finding new names is hard, but choosing a 3 letter acronym is a
>> recipe for problems...

I don't want to keep beating this dead horse, but the position from
the Perl community is that:
1. We picked the name 'pip' first (the release of Perl's pip precedes
Python's pip)
2. The author of Python's pip was informed of the naming conflict on his blog
3. The author chose to ignore it

And now we're in this mess. So, either the author is a jerk, or he
just didn't think anyone would be installing both on the same system.
But as we have the 'pip' package name, I think it is fair we get the
'pip' script name.

I see no reason for Perl's pip to have to change its name, simply
because the author of Python's pip chose a name which was already in
use by someone else, and because the author was already informed that
something like this might happen, and chose to proceed anyway.

> of course I'm s little biased on this, but I'm attending Pycon italia
> and 2 talks (over the 4 given by know) already provide explicit
> references to pip and also about how to use it (that's as simple as
> "pip install <module>").

What happens if someone releases a script called 'sh' and wants to
install it to /usr/bin/sh? Despite being informed that obviously it
conflicts with peoples' shells. I consider this a similar problem, but
on a much smaller scale (obviously Perl's pip is not as popular as
sh), but the point is still valid.

> would be another source of frustration for the python community
> willing to use debian (and that community is already being harmed
> several times).

Rather than cripple Perl's pip, if it's really not in use by anyone, I
think we should just remove the pip package and let Python take over
the name and /usr/bin path. But if it is in use, then given the author
of the Python script had advance warning, I think the "Python
community" effectively did this harm to themselves.

I do not think it is unreasonable to think of script names the same as
module names, as: "on a first-come, first-served basis" -- it is the
responsibility of each author to do a search to make sure they are not
picking the same names as anyone else. Not only did he fail to do
adequate research, he failed to predict this would happen and change
the name accordingly.

In summary: if we do not need the Perl version, remove it. If we need
the Perl version, its name should stay as 'pip'. This decision should
be made irrespective of Python's pip, because Perl's pip came first
(so I think it deserves that privilege).

Cheers,

Jonathan




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip. (Sat, 08 May 2010 13:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to gregor herrmann <gregoa@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Sat, 08 May 2010 13:00:03 GMT) Full text and rfc822 format available.

Message #139 received at 551926@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: Jonathan Yu <jawnsy@cpan.org>
Cc: Sandro Tosi <morph@debian.org>, 551926@bugs.debian.org, Raphael Hertzog <hertzog@debian.org>, ryan@debian.org, Carl Chenet <chaica@ohmytux.com>
Subject: Re: Bug#551926: [Python-modules-team] Bug#551926: cannot be installed together with pip or pip-python
Date: Sat, 8 May 2010 14:55:55 +0200
[Message part 1 (text/plain, inline)]
On Sat, 08 May 2010 08:27:40 -0400, Jonathan Yu wrote:

> I see no reason for Perl's pip to have to change its name, simply
> because the author of Python's pip chose a name which was already in
> use by someone else, and because the author was already informed that
> something like this might happen, and chose to proceed anyway.

The situation as I see it:
* Both upstream authors want to keep the name.
* Sandro wants the python package to keep pip, Jonathan wants the
  perl package to keep pip.
* Deadlock.

I guess that's why Raphaël pointed to the default resolution in such
situations:

| Hence all packages should rename their /usr/bin/pip to something else and
| document the difference vs upstream in README.Debian.

> In summary: if we do not need the Perl version, remove it. 

pip doesn't have any rdepends.
I was curious what it was needed for in the first place; I had a
hunch about padre, and indeed:

#v+
padre (0.59.ds1-1) unstable; urgency=low

[..]

    + remove pip from dependencies

[..]

 -- Damyan Ivanov <dmn@debian.org>  Fri, 09 Apr 2010 12:03:52 +0300

[..]

padre (0.48.ds2-1) unstable; urgency=low

  * New Upstream Version
    + new dependencies:

[..]
      - pip 0.13

[..]

 -- Damyan Ivanov <dmn@debian.org>  Thu, 29 Oct 2009 17:40:10 +0200
#v-

And indeed, the graphs on http://qa.debian.org/popcon-graph.php?packages=pip
look much like the dates when pip was added/removed as a dependency
of padre.


I'm not sure how useful/needed/... pip is on its own. But looking at
the (non-existant) rdepends and the popcon values I think RMing it
would be a viable solution.


Cheers,
gregor

-- 
 .''`.   http://info.comodo.priv.at/ -- GPG key IDs: 0x8649AA06, 0x00F3CFE4
 : :' :  Debian GNU/Linux user, admin, & developer - http://www.debian.org/
 `. `'   Member of VIBE!AT & SPI, fellow of Free Software Foundation Europe
   `-    NP: Spider Murphy Gang: Rock'n Roll Schuah
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip. (Sat, 08 May 2010 15:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sandro Tosi <morph@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Sat, 08 May 2010 15:45:03 GMT) Full text and rfc822 format available.

Message #144 received at 551926@bugs.debian.org (full text, mbox):

From: Sandro Tosi <morph@debian.org>
To: gregor herrmann <gregoa@debian.org>, 551926@bugs.debian.org
Cc: Jonathan Yu <jawnsy@cpan.org>, Raphael Hertzog <hertzog@debian.org>, ryan@debian.org
Subject: Re: [Python-modules-team] Bug#551926: Bug#551926: cannot be installed together with pip or pip-python
Date: Sat, 8 May 2010 17:43:11 +0200
Hi Gregor,

On Sat, May 8, 2010 at 14:55, gregor herrmann <gregoa@debian.org> wrote:
> On Sat, 08 May 2010 08:27:40 -0400, Jonathan Yu wrote:
>
>> I see no reason for Perl's pip to have to change its name, simply
>> because the author of Python's pip chose a name which was already in
>> use by someone else, and because the author was already informed that
>> something like this might happen, and chose to proceed anyway.
>
> The situation as I see it:
> * Both upstream authors want to keep the name.
> * Sandro wants the python package to keep pip, Jonathan wants the

just to clarify that it's not that I want it (i don't use it, after
all) but given how strongly it's advertised (and by such a big player
in the Python community as Raymond Hettinger, that mentioned it also
today), then I see definitely a problem in renaming it.

> pip doesn't have any rdepends.
> I was curious what it was needed for in the first place; I had a
> hunch about padre, and indeed:
...
> And indeed, the graphs on http://qa.debian.org/popcon-graph.php?packages=pip
> look much like the dates when pip was added/removed as a dependency
> of padre.
>
> I'm not sure how useful/needed/... pip is on its own. But looking at
> the (non-existant) rdepends and the popcon values I think RMing it
> would be a viable solution.

also looking at python-pip pocon (260, ~5 times more than
pip-after-padre effect, ~20 times more than before) and how low is
pip, and that also one of its maintainers is challanging its
usefulness :) I think that maybe removing it would be the lowest
impact action.

Regards,
-- 
Sandro Tosi (aka morph, morpheus, matrixhasu)
My website: http://matrixhasu.altervista.org/
Me at Debian: http://wiki.debian.org/SandroTosi




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>:
Bug#551926; Package pip,python-pip. (Sat, 08 May 2010 19:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>, Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>. (Sat, 08 May 2010 19:33:03 GMT) Full text and rfc822 format available.

Message #149 received at 551926@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: gregor herrmann <gregoa@debian.org>
Cc: Jonathan Yu <jawnsy@cpan.org>, Sandro Tosi <morph@debian.org>, 551926@bugs.debian.org, ryan@debian.org, Carl Chenet <chaica@ohmytux.com>
Subject: Re: Bug#551926: [Python-modules-team] Bug#551926: cannot be installed together with pip or pip-python
Date: Sat, 8 May 2010 21:30:54 +0200
reassign 551926 ftp.debian.org
retitle 551926 RM: pip -- tool for scripted and third-party CPAN distribution installation
thanks

On Sat, 08 May 2010, gregor herrmann wrote:
> I'm not sure how useful/needed/... pip is on its own. But looking at
> the (non-existant) rdepends and the popcon values I think RMing it
> would be a viable solution.

Ack, thanks for the investigation, it's a better outcome than having
several divergences compared to upstream.

Cheers,
-- 
Raphaël Hertzog

Like what I do? Sponsor me: http://ouaza.com/wp/2010/01/05/5-years-of-freexian/
My Debian goals: http://ouaza.com/wp/2010/01/09/debian-related-goals-for-2010/




Bug reassigned from package 'pip,python-pip' to 'ftp.debian.org'. Request was from Raphael Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Sat, 08 May 2010 19:33:06 GMT) Full text and rfc822 format available.

Changed Bug title to 'RM: pip -- tool for scripted and third-party CPAN distribution installation' from 'python-pip and pip: error when trying to install together' Request was from Raphael Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Sat, 08 May 2010 19:33:07 GMT) Full text and rfc822 format available.

Reply sent to Debian Archive Maintenance <ftpmaster@ftp-master.debian.org>:
You have taken responsibility. (Mon, 10 May 2010 12:36:03 GMT) Full text and rfc822 format available.

Notification sent to Ralf Treinen <treinen@free.fr>:
Bug acknowledged by developer. (Mon, 10 May 2010 12:36:04 GMT) Full text and rfc822 format available.

Message #158 received at 551926-close@bugs.debian.org (full text, mbox):

From: Debian Archive Maintenance <ftpmaster@ftp-master.debian.org>
To: 551926-close@bugs.debian.org
Cc: pip@packages.debian.org, pip@packages.qa.debian.org
Subject: Bug#551926: Removed package(s) from unstable
Date: Mon, 10 May 2010 12:34:21 +0000
We believe that the bug you reported is now fixed; the following
package(s) have been removed from unstable:

       pip |     1.16-1 | source, all

------------------- Reason -------------------
ROM; binary conflict with python-pip; no rdepends
----------------------------------------------

Note that the package(s) have simply been removed from the tag
database and may (or may not) still be in the pool; this is not a bug.
The package(s) will be physically removed automatically when no suite
references them (and in the case of source, when no binary references
it).  Please also remember that the changes have been done on the
master archive (ftp-master.debian.org) and will not propagate to any
mirrors (ftp.debian.org included) until the next cron.daily run at the
earliest.

Packages are usually not removed from testing by hand. Testing tracks
unstable and will automatically remove packages which were removed
from unstable when removing them from testing causes no dependency
problems. The release team can force a removal from testing if it is
really needed, please contact them if this should be the case.

Bugs which have been reported against this package are not automatically
removed from the Bug Tracking System.  Please check all open bugs and
close them or re-assign them to another package if the removed package
was superseded by another one.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 551926@bugs.debian.org.

The full log for this bug can be viewed at http://bugs.debian.org/551926

This message was generated automatically; if you believe that there is
a problem with it please contact the archive administrators by mailing
ftpmaster@debian.org.

Debian distribution maintenance software
pp.
Torsten Werner (the ftpmaster behind the curtain)




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 08 Jun 2010 07:30:50 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 07:36:43 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.